#include <stdio.h>
#include <stdlib.h>

#define MAXCHAR1 20
#define MAXCHAR2 50
#define MAXNUMPRODOTTI 50

/* definizione del tipo GLOBALE record di nome "prodotto" */
typedef struct
   {
   char codice[MAXCHAR1];
   char descrizione[MAXCHAR2];
   int giacenza;
   float prezzo;        
   } prodotto;


int main(int argc, char *argv[])
{
/* var. record di tipo prodotto utilizzata per eseguire la lettura/scrittura */
/* dal file indicato */    
prodotto prod;
prodotto magazzino[MAXNUMPRODOTTI];
char str_letta[255]="";
char str_letta1[255]="";
char *p;
FILE* f_input;
int i,j;

/* inizializzo l'indice dell'array */
i = 0;

/* apro il file di testo che contiene l'array di record */
f_input = fopen ("archivio.txt","r");
if (f_input != NULL)
   {
   printf ("****** CARICAMENTO VETTORE \"MAGAZZINO\" CON RECORD LETTI DA FILE *******\n");
   /* leggo la stringa formattata contenente ciascun record */
   /* N.B. la funzione fgets legge una riga del file fino allo \n */
   while (!(feof(f_input)) && (i < MAXNUMPRODOTTI) )
      {
      fgets (str_letta1, sizeof(prodotto), f_input);      
      strcpy(str_letta, str_letta1);  
      
      /* valorizzazione della variabile record locale letta da file */
      /* effettuando le dovute conversioni dove necessario e tenendo */
      /* conto del separatore scelto '|' */
      //printf("\nCodice       : ");
      strcpy(prod.codice, (char *) strtok(str_letta, "|"));
      //printf("%s\n", prod.codice);
   
      //printf("\nDescrizione  : ");
      strcpy(prod.descrizione, (char *) strtok(NULL, "|"));
      //printf("%s\n", prod.descrizione);
   
      //printf("\nGiacenza     : ");
      prod.giacenza =  atoi((char *) strtok(NULL, "|"));
      //printf("%d\n", prod.giacenza);
   
      //printf("\nPrezzo       : ");
      prod.prezzo =  atof((char *) strtok(NULL, "|"));
      //printf("%.2f\n\n", prod.prezzo);
      
      /* carico il record letto dal file nell'elemento -esimo del vettore */
      magazzino[i] = prod;
      
      /* mi sposto sull'elemento successivo del vettore */
      i = i + 1;    
       
      }
   
   /* chiudo il file */   
   fclose(f_input);
 
   printf ("***** VISUALIZZAZIONE VETTORE \"MAGAZZINO\" CARICATO IN MEMORIA *****\n");
   /* mostro a video i record caricati nel vettore "magazzino" */     
   for (j=0; j<i; j++)
      {
      printf ("\n%d^ Prodotto", j+1);
      printf ("\nCodice: %s", magazzino[j].codice);      
      printf ("\nDescrizione: %s", magazzino[j].descrizione);
      printf ("\nGiacenza: %d", magazzino[j].giacenza);
      printf ("\nPrezzo: %.2f", magazzino[j].prezzo);
      printf("\n");
      } 
   printf("\n\n");
   }         
else
   {
   printf ("\nErrore di apertura del file di input ");          
   }             



system("PAUSE");	
return 0;
}


